# Virtualizaciones y contenedores

## Instalación de _virtualBox_

Instalamos desde los repos de Ubuntu

```bash
sudo apt install virtualbox virtualbox-ext-pack virtualbox-guest-additions-iso virtualbox-guest-x11
```

## Docker

Tenemos que añadir el repositorio correspondiente a nuestra
distribución:

~~~~
# Be safe
sudo apt remove docker docker-engine docker.io
sudo apt autoremove
sudo apt update

# Install pre-requisites
sudo apt install ca-certificates curl gnupg lsb-release

# Import the GPG key
 sudo mkdir -m 0755 -p /usr/local/share/keyrings
 curl -fsSL https://download.docker.com/linux/debian/gpg | sudo gpg --dearmor -o /usr/local/share/keyrings/docker.gpg

# Add the repo for Docker

echo \
  "deb [arch=$(dpkg --print-architecture) signed-by=/usr/local/share/keyrings/docker.gpg] https://download.docker.com/linux/debian \
  $(lsb_release -cs) stable" | sudo tee /etc/apt/sources.list.d/docker.list > /dev/null

# Update the package database

sudo apt update
#

apt-cache policy docker-ce

sudo apt install docker-ce docker-ce-cli containerd.io docker-buildx-plugin docker-compose-plugin

sudo gpasswd -a username docker
~~~~

Esto dejará el servicio _docker_ funcionando y habilitado (arrancará
en cada reinicio del ordenador)

La forma de pararlo es:

~~~~{bash}
sudo systemctl stop docker
sudo systemctl disable docker
systemctl status docker
~~~~

Añadimos el _bundle_ __docker__ en nuestro fichero `~/.zshrc` para
tener autocompletado en comandos de docker.

Para usar _docker_ tendremos que arrancarlo, con los alias de nuestro sistema para _systemd_ ejecutamos:

~~~~{bash}
scst docker  # para arrancar el servicio

scsp docker  # para parar el servicio
~~~~
